def proc draw_main
rem draw the main play area
local lp%
  wm_paper#scr_chan%,sp.appbg		: rem set paper
  cls#scr_chan%
  for lp%=1 to stopsquare%
    draw_one_square lp% 		: rem and draw each square in turn
  end for lp%				: rem surely there's a quicker way?
end def draw_main
:
def proc draw_one_square (square%)
rem This draws one square and puts the ball sprite in it (if any)
rem Squares start at 1, end at stopsquare%
rem There are rows% squares per row - and rows% rows
rem csmain% is from "main" procedure
local xo%,yo%,sw%
  xo%= (square% mod rows%)*xsquares%  - xsquares% : rem x origin of this square
  sw%=1
  if xo%<0
    xo%=(rows%-1)*xsquares%		: rem correct for last element in row
    sw%=0
  endif
  yo%= ((square% div rows%) +sw%)*ysquares% -ysquares%
  window#scr_chan%,xsquares%,ysquares%,xo%+csmain%(2),yo%+csmain%(3): rem channel covers this square
  wm_paper#scr_chan%,sp.appbg
  cls#scr_chan% 			: rem and empty it
  wm_block#scr_chan%,1,ysquares%,xsquares%-1,0,sp.3ddark : rem right
  wm_block#scr_chan%,xsquares%,1,0,ysquares%-1,sp.3ddark : rem down
  wm_block#scr_chan%,1,ysquares%,0,0,sp.3dlight 	 : rem left
  wm_block#scr_chan%,xsquares%,1,0,0,sp.3dlight 	 : rem up
  dr_awdf#scr_chan%,main_defn,0 	: rem reset channel to main appsub wdw
  if squares%(square%):print_sprite square%,0
end def draw_one_square
:
def proc print_sprite (square%,sprite)
rem write a sprite into the given square
rem sprite size = 15*14
rem ths sprite type is taken from the global squares% array
local xo%,yo%,sw%,temp%,addr,sp_xs%,sp_ys%,temp1%,offset%
  if squares%(square%)=0:ret		: rem square is empty!
  xo%= (square% mod rows%)*xsquares%  - xsquares%
  sw%=1
  if xo%<0
    xo%=(rows%-1)*xsquares%
    sw%=0
  endif
  yo%= ((square% div rows%) +sw%)*ysquares% -ysquares%
  if not sprite
    sprite=sprites(squares%(square%))
    if small_sprites%
      addr=peek_l(sprite+20)		: rem sprite too big, take smaller one
      addr=sprite+20+addr
    else
      addr=sprite
    endif
    sp_xs%=peek_w(addr+4)		: rem sprite x size
    sp_ys%=peek_w(addr+6)		: rem sprite y size
    temp%=(ysquares%-sp_ys%) div 2	: rem center y
    yo%=yo%+temp%
    temp%=(xsquares%-sp_xs%) div 2	: rem make sure sprite is centered - x
    xo%=xo%+temp%
    wsprt #scr_chan%,xo%,yo%,addr
  else
    if small_sprites%
      addr=peek_l(sprite+20)
      addr=sprite+addr+20		: rem point to smaller sprites
    else
      addr=sprite
    endif
    temp%=peek_w(addr+8)		: rem sprite
    xo%=xo%+temp%
    temp%=peek_w(addr+10)
    yo%=yo%+temp%
    wsprt #scr_chan%,xo%,yo%,addr
  endif
end def print_sprite
:
def proc draw_numbers
rem uses the global variable totalmoves%
local a$,llen%
  a$=totalmoves%
  llen%=len(a$)
  if llen%<3:a$=fill$('0',3-llen%)&a$:llen%=3
  dr_iwdf#tot_chan%,main_defn,4
  paper#tot_chan%,0
  cls#tot_chan%
  wl_draw_led#tot_chan%,orange,llen%,a$
end def draw_numbers
:
def proc draw_new_sprites
rem this makes new "seeds" and draws the sprites in the "next" window
  new_seed
  dr_iwdf#tot_chan%,main_defn,3
  wm_paper#tot_chan%,sp.infwinbg
  cls#tot_chan%
  wsprt#tot_chan%,4,8,sprites (seed%(0))
  wsprt#tot_chan%,32,8,sprites (seed%(1))
  wsprt#tot_chan%,60,8,sprites (seed%(2))
end def draw_new_sprites
:
